//
// automatically generated by spin2cpp v1.92 on Thu Jun 11 20:24:36 2015
// spin2cpp --main fs.spin 
//

// =================================================
// Fibonacci Spiral
// by T.Whitfield Stodghill, III
// May 4, 2015
// Inspired by Nikos Giannakopoulos Artist Robot
// =================================================
//
// Load program and place pen in pen port. Press the
// reset button to run program. S2 will scribble a
// Fionacci Spiral.
//
#include <propeller.h>
#include "fs.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#endif

int32_t fs::start(void)
{
  // Start the S2 object
  s2abl.start();
  // Start the motor cog.
  s2mot.start_motors();
  // Set button mode to display in LEDs and to reset.
  s2abl.button_mode(-1, -1);
  // Turn on the power LED.
  s2abl.set_led(s2ABL::POWER, s2ABL::BLUE);
  // Per Phil Pilgirm (your milage may vary)
  s2mot.set_wheel_calibration((s2MotDrv::DEFAULT_FULL_CIRCLE - 5), s2MotDrv::DEFAULT_WHEEL_SPACE);
  if (s2abl.reset_button_count()) {
    // Do only if reset was via a button, rather than powerup.
    // Set speed to 50%.
    s2mot.set_speed(7);
    // Set the start point
    s2mot.here_is(0, 0);
    // Begin a smooth drawing path.
    s2mot.begin_path();
    // Curve ccw 90 degrees with a radius of 10
    s2mot.arc_deg(90, 10);
    // Curve ccw 90 degrees with a radius of 20
    s2mot.arc_deg(90, 20);
    // Curve ccw 90 degrees with a radius of 30
    s2mot.arc_deg(90, 30);
    // Curve ccw 90 degrees with a radius of 50
    s2mot.arc_deg(90, 50);
    // Curve ccw 90 degrees with a radius of 80
    s2mot.arc_deg(90, 80);
    // Curve ccw 90 degrees with a radius of 130
    s2mot.arc_deg(90, 130);
    // Curve ccw 90 degrees with a radius of 210
    s2mot.arc_deg(90, 210);
    // Curve ccw 90 degrees with a radius of 340
    s2mot.arc_deg(90, 340);
    // Curve ccw 90 degrees with a radius of 550
    s2mot.arc_deg(90, 550);
    // Curve ccw 90 degrees with a radius of 890
    s2mot.arc_deg(90, 890);
    // End the drawing path.
    s2mot.end_path();
  }
  return 0;
}

fs MainObj__;

int main() {
  return MainObj__.start();
}

// ---[End of Program]-----------------------------------------------------------
/* 
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */


